/*
Plugin Name: Download from files
Plugin URI:  http://wpdemo.dovi42.hu/download-from-files
Description: Letölthető fájlok a fájlrendszerből.
Version:     0.05
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: download-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-03-08 07:34:34
*/

/*
Átadott ajax változók: 
Passed ajax variables: 
-------------------------------------------: 
var download_from_files_variables_<token> = [
		'accept'          : 'doc,docx,pdf,xls,xlsx,zip,jpg,png',
		'sort_folders'    : 'set',
		'sort_files'      : 'set,name,title,date,size,ext',
		'hide_direct_url' : '1'
		// Valamint azok a változók, amelyek a híváskor lettek definiálva 
		// Also, the variables that were defined at the time of the call 

		// Lásd: javascript a konzolt! 
		// See: javascript console! 
   ];
*/

var get_name_html_box = '';
var files_list = [];
var group_title = '';
var gauge_max = 0;


jQuery(document).ready(function() {

    jQuery.noConflict();

    download_from_files_checkSelected();
    get_name_html_box = jQuery('#download_get_name').html();
    jQuery('#download_get_name').remove();

    jQuery('.sortable' ).sortable({
        placeholder: 'ui-state-highlight',
        forcePlaceholderSize: true,
        items: 'li:not(.sort-disabled)',
        start: function(e, ui) { 
            ui.placeholder.css({
                'visibility' : 'visible',
                'background-color' : '#FFFFD6'
            });
        },
        stop:  function (event, ui) {
            ui.item.find('a').off('click');
            download_from_files_617_saveDownloadOrder();
        }
    }).disableSelection();

    jQuery('.file-select').change(function() {
        download_from_files_checkSelected();
    });

    jQuery("#files_upload").on('submit',(function(e) {
        e.preventDefault();
        
        download_from_files_617_gaugeInit(0);

        jQuery.ajax({
            url  : download_from_files_617_ajax_object.ajax_url,
            type : "POST",
            data :  new FormData(this),
            contentType: false,
            cache: false,
            processData:false,
            dataType : 'json',
            beforeSend : function() {
                //$("#preview").fadeOut();
                jQuery("#err").fadeOut();
            },
            success: function(data, result) {
                if (data.status == 1) {
                    jQuery('#myfile').val('');
                    location.reload();
                } else {
                    jQuery('#download-job-gauge').fadeOut();
                    download_from_files_617_hideOverlay();
                    var html = '<div class="alert alert-info" role="alert">'+data.message+'</div>';
                    jQuery("#err").html(html).fadeIn();
                    setTimeout(function(){ 
                        jQuery("#err").html('').fadeOut(); 
                    }, 5000);
                }
            },
            error: function(e) {
                jQuery("#err").html(e).fadeIn();
            }          
        });
    }));


    download_from_files_617_setDownloadMargins();        
});

jQuery( window ).on('resize', function(){
	download_from_files_617_resetDownloadMargins();
});

function download_from_files_checkSelected() {
    var selected = true;
    jQuery('#files').children('li').each(function( index ) {
        if (jQuery(this).find('.file-select').prop('checked')) {
            selected = false;
        }
    });
    var buttons = ['button_delete_selected', 'button_rename_selected'];
    buttons.forEach(function(item, index) {
       jQuery('#'+item).prop('disabled', selected);    
    });
}

function download_from_files_617_select_all() {
    jQuery('#files').children('li').each(function( index ) {
        jQuery(this).find('.file-select').prop('checked', true);
    });
    download_from_files_checkSelected();
}

function download_from_files_617_unselect_all() {
    jQuery('#files').children('li').each(function( index ) {
        jQuery(this).find('.file-select').prop('checked', false);
    });
    download_from_files_checkSelected();
}


function download_from_files_617_setDownloadMargins() {

    var downloads = jQuery('#download-content');
    var token   = 'download-from-files';
    
    var line = 1;
    var w = downloads.width();
    var line_width = 0;
    var cnt = 0;
    var margin = 0;
    
    downloads.find('li').each(function(){
        var img_w = jQuery(this).outerWidth();
        if ((line_width + jQuery(this).outerWidth()) < w) {
            line_width = line_width + img_w;
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt++; 
        } else {
            cnt--;
            margin = Math.floor((w - line_width) / cnt);
            jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
            jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
            line++;
            jQuery('<div class="clearfix" style="clear:both;"></div>').insertBefore(this);
            jQuery(this).addClass(token + '-line-' + line);
            jQuery(this).attr('data-class', token + '-line-' + line);
            cnt = 1;
            line_width = img_w;
        }                
    });    
    cnt--;
    var margin2 = Math.floor((w - line_width) / cnt);
    if (margin2 < margin) { margin = margin2; }
    if (margin == 0) { margin = 12; }
    jQuery('.'+token + '-line-' + line).css('margin-right', margin + 'px');
    jQuery('.'+token + '-line-' + line + ':last').css('margin-right', '0px');
}

function download_from_files_617_resetDownloadMargins() {

    var download = jQuery('#download-content');
    var token   = 'download-from-files';

	download.find('.clearfix').remove();
    download.find('li').each(function(){
        jQuery(this).removeClass( jQuery(this).attr('data-class') );
        jQuery(this).removeAttr('data-class');
        jQuery(this).css('margin-right', '0px');    
	});
    download_from_files_617_setDownloadMargins();
}


function download_from_files_617_saveDownloadOrder() {
    var list = [];
    jQuery('#folders').children('li').each(function( index ) {
        if (jQuery(this).attr('data-filename') != '[up]') {
            list.push( jQuery(this).attr('data-filename') );
        }
    });
    jQuery('#files').children('li').each(function( index ) {
        list.push( jQuery(this).attr('data-filename') );
    });

    var data = {
            action : 'download_from_files_617_sort_reorder',
            order  : JSON.stringify(list),
            path   : jQuery('#folders').attr('data-path')
        };
        
    jQuery.ajax({
        url      : download_from_files_617_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                download_from_files_617_resetDownloadMargins();
            } else {
                alert(data.message);
            }
        } 
    });
}

function download_from_files_617_setViewPath(path) {
    var host = window.location.host,
        exdate = new Date();
    exdate.setDate(exdate.getDate() + 365);
    document.cookie = 'download-from-files-path=' + path + ';  expires=' + exdate.toUTCString() + '; path=/; domain='+host;
    location.reload();
}

function download_from_files_617_deleteFolder(item) {
    var id = item.closest('li').attr('id');
    jQuery('#'+id).find('.delete_folder_icon').find('.dashicons').toggleClass('dashicons-trash dashicons-update-alt').addClass('spin');

    var data = {
            action   : 'download_from_files_617_delete_folder',
            filename : jQuery('#'+id).attr('data-filename'),
            path     : jQuery('#folders').attr('data-path')
        };

    jQuery.ajax({
        url      : download_from_files_617_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){

            if (data.status == 1) {
                jQuery('#'+id).fadeOut(500);
                setTimeout(function(){ 
                    jQuery('#'+id).remove();
                    download_from_files_617_resetDownloadMargins(); 
                }, 550);
            } else {
                jQuery('#'+id).find('.delete_folder_icon').find('.dashicons').toggleClass('dashicons-trash dashicons-update-alt').removeClass('spin');
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}

function download_from_files_617_showTitleBox(text, input) {

    var html = get_name_html_box;

    var box = '<div id="messageBox" class="messageBox" style="z-index:1001;">' 
            + html 
            + '</div>';

    download_from_files_617_showOverlay();
    jQuery('body').append( box );
    jQuery('.download_get_title_label').html(text);
    jQuery('#messageBox').find('.message_functions').prepend(input);
    var action = jQuery('#messageBox').find('.button-primary').attr('onclick'); 
//  jQuery('#messageBox').find('.button-primary').attr('onsubmit', action);
    jQuery('#messageBox').find('form').attr('action', 'javascript:' + action);

    var t = Math.floor((jQuery(window).height() - jQuery('#messageBox').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#messageBox').width()) / 2);
    jQuery('#messageBox').css('top', t + 'px');
    jQuery('#messageBox').css('left', l + 'px');
    jQuery('#messageBox').fadeIn();
    jQuery('.download_get_title_label:first').focus();
}

function download_from_files_617_hideTitleBox() {
    jQuery('#messageBox').hide();
    jQuery('#messageBox').remove();
    download_from_files_617_hideOverlay();
}

function download_from_files_617_showOverlay() {
    var over = '<div id="overlay" class="overlay" style="z-index:1000;"></div>';
    jQuery('body').prepend(over);
    jQuery('#overlay').width( jQuery(window).width() );
    jQuery('#overlay').height( jQuery(window).height() );
    jQuery('#overlay').fadeIn(200);
}

function download_from_files_617_hideOverlay() {
    jQuery('#overlay').fadeOut(200);
    setTimeout(function() {
        jQuery('#overlay').remove();
    }, 250);    
}


function download_from_files_617_new_folder_box()
{
    var input = '<input onclick="download_from_files_617_addNewFolder();" type="submit" class="button button-primary" value="'+download_lang['ADD']+'" />';
    download_from_files_617_showTitleBox(download_lang['NEW_FOLDER_LABEL'], input);    
}

function download_from_files_617_addNewFolder() {

    var title = jQuery('#download_get_title').val();
    download_from_files_617_hideTitleBox();

    if (title != null && title != '') {

        jQuery('#add_new_folder_icon').removeClass('dashicons-plus');
        jQuery('#add_new_folder_icon').addClass('dashicons-update');
        jQuery('#add_new_folder_icon').addClass('spin');

        var data = {
                action : 'download_from_files_617_new_folder',
                title  : title,
                path   : jQuery('#folders').attr('data-path')
            };
        
        jQuery.ajax({
            url      : download_from_files_617_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data,
            success  : function(data, result){

                jQuery('#add_new_folder_icon').removeClass('spin');
                jQuery('#add_new_folder_icon').removeClass('dashicons-update');
                jQuery('#add_new_folder_icon').addClass('dashicons-plus');

                if (data.status == 1) {
                    jQuery('#folders').append(data.html);
                    download_from_files_617_resetDownloadMargins();
                } else {
                    alert(data.message);
                }
            },
            error: function (request, status, error) {
                alert('AJAX error : ' + status);
            } 
        });
    }
}

function download_from_files_617_my_trim(text) {
    text = text.replace('[', '');
    text = text.replace(']', '');
    text = text.trim();
    return text;
}

function download_from_files_617_edit_folder_box(item)
{
    var id = item.closest('li').attr('id');
    var title = jQuery('#'+id).find('.download-from-files-thumbnail-title:first').text();
    title = download_from_files_617_my_trim(title);
    
    var input = '<input onclick="download_from_files_617_editFolderTitle();" type="button" class="button button-primary" value="'+download_lang['RENAME']+'" />'
              + '<input id="edited_id" type="hidden" value="'+id+'" />'
              + '<input id="edited_title" type="hidden" value="'+title+'" />';
    download_from_files_617_showTitleBox(download_lang['EDIT_TITLE_LABEL'], input);    
    jQuery('#download_get_title').val(title);
}

function download_from_files_617_editFolderTitle() {

    var id        = jQuery('#edited_id').val();
    var title     = jQuery('#edited_title').val();
    var new_title = jQuery('#download_get_title').val();
    download_from_files_617_hideTitleBox();

    if (new_title != null && new_title != '' && new_title != title ) {

        jQuery('#'+id).find('.edit_folder_icon').find('.dashicons').toggleClass('dashicons-admin-comments dashicons-update-alt').addClass('spin');

        var data = {
                action   : 'download_from_files_617_js_edit_folder',
                id       : id,
                title    : new_title,
                filename : jQuery('#'+id).attr('data-filename'),
                path     : jQuery('#folders').attr('data-path')
            };
    
        jQuery.ajax({
            url      : download_from_files_617_ajax_object.ajax_url,
            dataType : 'json',
            type     : 'POST',
            data     : data,
            success  : function(data, result){

                jQuery('#'+id).find('.edit_folder_icon').find('.dashicons').toggleClass('dashicons-admin-comments dashicons-update-alt').removeClass('spin');

                if (data.status == 1) {
                    jQuery('#'+data.id).find('.download-from-files-thumbnail-title').text(data.title);
                    jQuery('#'+data.id).attr('data-filename', data.filename);
                } else {
                    alert(data.message);
                }
            },
            error: function (request, status, error) {
                alert('AJAX error : ' + status);
            } 
        });
    }    
}

function download_from_files_617_edit_image_box(item)
{
    var id = item.closest('li').attr('id');
    var title = jQuery('#'+id).find('.download-from-files-thumbnail-title:first').text();
    title = download_from_files_617_my_trim(title);
    
    var input = '<input onclick="download_from_files_617_editFolderTitle();" type="button" class="button button-primary" value="'+download_lang['RENAME']+'" />'
              + '<input id="edited_id" type="hidden" value="'+id+'" />'
              + '<input id="edited_title" type="hidden" value="'+title+'" />';
    download_from_files_617_showTitleBox(download_lang['EDIT_FILE_TITLE'], input);    
    jQuery('#download_get_title').val(title);
}

function download_from_files_617_getSelected() {
    var ids = [];
    jQuery('#files').children('li').each(function( index ) {
        if (jQuery(this).find('.file-select').prop('checked')) {
            ids.push( jQuery(this).attr('id') );
        }
    });
    if (ids.length == 0) {
        alert( download_lang['NEED_SELECTED_FILES'] );        
    } else {
        files_list = ids;
    }
}

function download_from_files_617_groupTitles() {
    
    download_from_files_617_getSelected();

    if (files_list.length < 1) {
        return false;
    }
    
    var input = '<input onclick="download_from_files_617_set_group_titles();" type="button" class="button button-primary" value="'+download_lang['RENAME']+'" />';
    download_from_files_617_showTitleBox(download_lang['SELECTED_FILES_TITLE'], input);    
}

function download_from_files_617_set_group_titles() {
    group_title = jQuery('#download_get_title').val();
    download_from_files_617_hideTitleBox();

    if (files_list.length < 1) {
        return false;
    }

    download_from_files_617_gaugeInit(files_list.length);

    jQuery('#group_title_icon').removeClass('dashicons-admin-comments');
    jQuery('#group_title_icon').addClass('dashicons-update');
    jQuery('#group_title_icon').addClass('spin');

    download_from_files_617_set_one_title();
}

function download_from_files_617_set_one_title() {

    if (files_list.length < 1) {
        return false;
    }
    var id = files_list[0];
    files_list.splice(0, 1);

    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#files').attr('data-path');
    
    var data_tmp = {action : 'download_from_files_617_edit_description',
                    id       : id,
                    title    : group_title,
                    path     : path,
                    filename : filename};
    jQuery.ajax({
        url      : download_from_files_617_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data_tmp,
        success  : function(data, result){
            if (data.status == 1) {
                jQuery('#'+data.id).find('.file-select').prop('checked', false);
                jQuery('#'+data.id).attr('data-filename', data.filename);

                jQuery('#'+data.id).find('.download-from-files-thumbnail-title').html( data.title );
                download_from_files_617_gaugeUpdate(files_list.length);

                if (files_list.length < 1) {
                    jQuery('#group_title_icon').removeClass('spin');
                    jQuery('#group_title_icon').removeClass('dashicons-update');
                    jQuery('#group_title_icon').addClass('dashicons-admin-comments');
                    download_from_files_617_saveDownloadOrder();
                } else {
                    download_from_files_617_set_one_title();    
                }

            } else {
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
}


function download_from_files_617_gaugeInit(max) {
    if (max == '' || Number(max) < 1) {
        jQuery('#download-job-gauge').find('.gauge-line').hide();
        jQuery('#download-job-gauge').find('.percent').hide();
        jQuery('#download-job-gauge').find('.wait-image').show();
    } else {
        gauge_max = Number(max);
        jQuery('#download-job-gauge').find('.gauge').width(0);
        jQuery('#download-job-gauge').find('.gauge-line').show();
        jQuery('#download-job-gauge').find('.percent').html('0%');
        jQuery('#download-job-gauge').find('.percent').show();
        jQuery('#download-job-gauge').find('.wait-image').hide();
    }
    download_from_files_617_showOverlay();
    var t = Math.floor((jQuery(window).height() - jQuery('#download-job-gauge').height()) / 2);
    var l = Math.floor((jQuery(window).width() - jQuery('#download-job-gauge').width()) / 2);
    jQuery('#download-job-gauge').css('top', t + 'px');
    jQuery('#download-job-gauge').css('left', l + 'px');
    jQuery('#download-job-gauge').fadeIn();
}

function download_from_files_617_gaugeUpdate(percent) {
    percent = Number(percent);
    percent = percent / (gauge_max / 100);
    percent = 100 - Math.round(percent);
    jQuery('#download-job-gauge').find('.percent').html(percent + '%');
    jQuery('#download-job-gauge').find('.gauge').width((percent * 2));
    if (percent >= 100) {
        download_from_files_617_hideOverlay();
        jQuery('#download-job-gauge').fadeOut();
    }
}


function download_from_files_617_selected_delete() {
    download_from_files_617_getSelected();

    if (files_list.length < 1) {
        return false;
    }

    jQuery('#group_delete_icon').removeClass('dashicons-trash');
    jQuery('#group_delete_icon').addClass('dashicons-update');
    jQuery('#group_delete_icon').addClass('spin');

    download_from_files_617_gaugeInit(files_list.length);
    download_from_files_617_delete_file();
}

function download_from_files_617_delete_file() {

    if (files_list.length < 1) {
        return false;
    }

    var id = files_list[0];
    files_list.splice(0, 1);
    
    var filename = jQuery('#'+id).attr('data-filename');
    var path = jQuery('#files').attr('data-path');

    var data = {
            action : 'download_from_files_617_delete_file',
            id       : id,
            path     : path,
            filename : filename
        };

    jQuery.ajax({
        url      : download_from_files_617_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {

                jQuery('#'+data.id).find('.file-select').prop('checked', false);
                jQuery('#'+data.id).fadeOut(200);
                setTimeout(function(){ 
                    jQuery('#'+data.id).remove();
                }, 250);

                download_from_files_617_gaugeUpdate(files_list.length);
                if (files_list.length < 1) {
                    jQuery('#group_delete_icon').removeClass('dashicons-update');
                    jQuery('#group_delete_icon').removeClass('spin');
                    jQuery('#group_delete_icon').addClass('dashicons-trash');
                    
                    download_from_files_617_resetDownloadMargins();
                    download_from_files_checkSelected();
                } else {
                    download_from_files_617_delete_file()
                }
            } else {
                download_from_files_617_gaugeUpdate(0);
                alert(data.message);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    
}

function download_from_files_617_copy_to_clipboard() {
    
    jQuery('.shortcode').find('.dashicons').toggleClass('dashicons-shortcode dashicons-update-alt').addClass('spin');
    
    text = jQuery('.shortcode').find('.code:first').text();
    var temp = jQuery("<input>");
    jQuery("body").append(temp);
    temp.val(text).select();
    document.execCommand("copy");
    temp.remove();    

    setTimeout(function() {
        jQuery('.spin').toggleClass('dashicons-shortcode dashicons-update-alt').removeClass('spin');
    }, 100); 
    
}

function download_from_files_617_copy_file_to_clipboard(item) {

    item.find('.dashicons').toggleClass('dashicons-shortcode dashicons-update-alt').addClass('spin');

    let variables = [
            'download-from-files'
        ];

    let file = item.closest('li');
    variables.push( 'target="'+jQuery('.shortcode:first').attr('data-folder')+'/'+file.attr('data-filename')+'"' );

    text = '[' + variables.join(' ') + ']';

    var temp = jQuery("<input>");
    jQuery("body").append(temp);
    temp.val(text).select();
    document.execCommand("copy");
    temp.remove();    
    
    setTimeout(function() {
        jQuery('.spin').toggleClass('dashicons-shortcode dashicons-update-alt').removeClass('spin');
    }, 100); 
    
}

function download_from_files_change_template() {
    var mode = 'download-from-files';
    var text = ' target="'+jQuery('.shortcode:first').attr('data-folder')+'"';
    if (jQuery('#template_selector').val() != '') {
        if (jQuery('#template_selector').val() == 'tree') {
            mode = 'download-from-tree';
        } else {
            text +=  ' template="'+jQuery('#template_selector').val()+'"'
        }
    }
    text += ']';
    text = '['+mode+text;
    jQuery('.code').text(text); 
}
