var download_from_files_select_path = '';
var download_from_files_is_file = false;

jQuery( document ).ready(function() {
    
    jQuery('#download_from_files_tree').jstree({
            'core' : {
                'strings' : {'Loading ...' : 'Betöltés folyamatban, kérem, várjon ...!'},
                'multiple' : false,
                'animation' : 200,
                'themes' : { 'stripes' : true },
                'data' : {
                  'url' : downloads_from_files_data.url,
                  'data' : function (node) {
                    return { 'id'    : node.id,
                             'path'  : this.get_path(node, '/', true),
                             'ext'   : download_from_files_options.accept,
                             'root'  : downloads_from_files_data.root,
                             'url'   : download_from_files_options.url};
                  }
                }
            },
            'unique' : {
				'duplicate' : function (name, counter) {
					return name + ' (' + counter + ')';
				}
			},            
            'plugins' : [
                'unique', 'state', 'search', 'types', 'wholerow'
                ],
        })
        .on('changed.jstree', function (e, data) {
            
            var item = data.instance.get_node(data.node);
            
            if (typeof item.data !== 'undefined') {
                if (typeof item.data.file !== 'undefined') {
                    download_from_files_select_path = item.data.file; 
                    download_from_files_is_file = true;
                    jQuery('.download-insert-functions').css('opacity', 0);
                } else {
                    download_from_files_select_path = data.instance.get_path(data.node, '/', true);
                    download_from_files_select_path = download_from_files_select_path.replace('home/', '');
                    download_from_files_is_file = false;
                    jQuery('.download-insert-functions').css('opacity', 1);
                    
                }
            }
            if (download_from_files_select_path != '') {
                jQuery('#insertFileDownload').removeAttr('disabled');
            }
        });
        
        var to = false;

        jQuery('#search_download').keyup(function () {
            if(to) { clearTimeout(to); }
            to = setTimeout(function () {
                var v = jQuery('#search_download').val();
                jQuery('#download_from_files_tree').jstree(true).search(v);
            }, 250);
        });        

});          

      function loadNodes(tree, node, cb) {
          var nodeId = node.id == "#" ? "" : node.id;
              
          var sfNode = new SObjectModel.sfNode();
          
          sfNode.retrieve({ 
              where: {Parent: {eq: nodeId}}, 
              limit: 100 }, 
              function(err, records) {
              if (err) {
                  displayErr(err);
              } else {
                  var nodes = [];
                  records.forEach(function(record) {
                      nodes.push({ 
                          id: record.get("Id"),
                          text: record.get("Name"),
                          children: true
                      });
                  });       
                  cb.call(tree, nodes);
              }
          });
}

jQuery('#insertFileDownload').on('click', function() {
    var mode = 'download-from-files';
    var text = ' target="' + download_from_files_select_path + '"';
    
    if (jQuery('#template_selector').val() != '') {
        if (jQuery('#template_selector').val() == 'tree') {
            mode = 'download-from-tree';
        } else {
            text +=  ' template="'+jQuery('#template_selector').val()+'"'
        }
    }

    if (!download_from_files_is_file) {
        
        if (jQuery('#show_folders').prop('checked')) {
            text += ' folders="1"';
        } else {
            text += ' folders="0"';
        }
    }
    
    text += ']';
    text = '['+mode+text;

    wp.media.editor.insert(text);
    tb_remove();
});
jQuery('#cancelFileDownload').on('click', function() {
    tb_remove();
});
