var download_from_files_select_path = '';
var download_from_files_is_file = false;
var to = false;

jQuery( document ).ready(function() {

    jQuery('.download-from-tree').each(function(i, obj) {
        
        var token = jQuery(this).attr('data-token');
		if (typeof token !== 'undefined' && token !== null) {
			var variables = eval('download_from_files_variables_' + token);

            jQuery('#download_from_tree_'+token).jstree({
                    'core' : {
                        'strings' : {'Loading ...' : download_from_tree_sets.loading_please_wait_text },
                        'multiple' : false,
                        'animation' : 200,
                        'themes' : { 
                            'stripes' : true, 
                            'variant' : 'large'
                        },
                        'data' : {
                            'url' : download_from_tree_sets.downloads_from_files_plugin_url,
                            'data' : function (node) {
                                return { 'id'    : node.id,
                                         'path'  : this.get_path(node, '/', true),
                                         'ext'   : variables.accept,
                                         'root'  : download_from_tree_sets.ABSPATH + variables.target,
                                         'url'   : variables.url,
                                         'disabled' : variables.disabled,
                                         'sort_folders': variables.sort_folders,
                                         'sort_files': variables.sort_files,
                                         'sort_order': variables.sort_order,
                                         'template': variables.tmpl};
                                    }
                            },
                        'loaded_state' : false
                    },
                    'unique' : {
        				'duplicate' : function (name, counter) {
        					return name + ' (' + counter + ')';
        				}
        			},            
                    'plugins' : [
                        'unique', 'search', 'types', 'wholerow'
                        ],
                })
                .on('changed.jstree', function (e, data) {
                    
                    var item = data.instance.get_node(data.node);
                    
                    if (item && (typeof item.data.file !== 'undefined')) {

                        var variables = eval('download_from_files_variables_' + token);
                        var file = variables.target + '/' + item.data.file;
                        file = file.replaceAll('//', '/');
                        
                        if (variables.hide_direct_url != '0') {
                            download_from_files_617_download_file_tree(file);                            
                        } else {
                            file = variables.home + file;
                            window.open(file, '_self');
                        }

                    }
                });

                jQuery('#search_download_'+token).keyup(function () {
                    if(to) { clearTimeout(to); }
                    to = setTimeout(function () {
                        var v = jQuery('#search_download_'+token).val();
                        jQuery('#download_from_tree_'+token).jstree(true).search(v);
                    }, 250);
                });        


		}
    });    

});     

function download_from_files_617_download_file_tree(file) {

    var data = {
            action    : 'download_from_files_617_download_file',
            no_encode : 1,
            file      : file
        };

    jQuery.ajax({
        url      : download_from_files_617_ajax_object.ajax_url,
        dataType : 'json',
        type     : 'POST',
        data     : data,
        success  : function(data, result){
            if (data.status == 1) {
                // Status OK
                if (data.status == 1) {
                    const downloadLink = document.createElement('a');
                    downloadLink.href     = 'data:application/'+data.type+';base64,' + data.file;
                    downloadLink.download = data.filename;
                    downloadLink.click();
                }

            } else {
                alert(data.error);
            }
        },
        error: function (request, status, error) {
            alert('AJAX error : ' + status);
        } 
    });
    
}
     
/*
function loadNodes(tree, node, cb) {
    var nodeId = node.id == "#" ? "" : node.id;
    
    var sfNode = new SObjectModel.sfNode();
    
    sfNode.retrieve({ 
        where: {Parent: {eq: nodeId}}, 
    limit: 100 }, 
    function(err, records) {
        if (err) {
            displayErr(err);
        } else {
            var nodes = [];
            records.forEach(function(record) {
                nodes.push({ 
                    id: record.get("Id"),
                    text: record.get("Name"),
                    children: true
                });
            });       
            cb.call(tree, nodes);
        }
    });
}
*/
