<?php
/*
Plugin Name: Download from files
Plugin URI:  http://wpdemo.dovi42.hu/download-from-files
Description: Downloaded files from file system.
Version:     1.53
Author:      Dovi42
Author URI:  http://dovi42.hu/
License:     GPLv2 or later
License URI: https://www.gnu.org/licenses/gpl-2.0.html
Text Domain: download-from-files
Generator:   WP Creator - http://wpcreator.hu - 2020-03-08 07:34:34
*/

if ( !defined( 'ABSPATH' ) ) exit;

if (!defined('DS')) { define( 'DS', DIRECTORY_SEPARATOR ); }

define('DOWNLOAD_FROM_FILES_617_ROOT', dirname(__file__));
define('DOWNLOAD_FROM_FILES_617_VERSION', '1.53');

if (!defined('DOWNLOAD_FROM_FILES_617_WP_ROOT')) {
    $path = explode(DS, DOWNLOAD_FROM_FILES_617_ROOT);    
    $path = array_slice($path, 0, -3);
    $path = implode(DS, $path).DS;
    define('DOWNLOAD_FROM_FILES_617_WP_ROOT', $path);
}

function download_from_files_617_update() {
    require_once ( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'autoupdate.php' ); 
	
	$plugin_current_version = DOWNLOAD_FROM_FILES_617_VERSION; // Current version
	$plugin_remote_path     = 'http://update.dovi42.hu/download-from-files/update.php';  
	$plugin_slug            = plugin_basename(__file__);
	$license_user           = get_site_url();
	$license_key            = '<optional license key>';

	if ( $license_user && $license_key && $plugin_remote_path )
	{
		new download_from_files_617_AutoUpdate ($plugin_current_version, $plugin_remote_path, $plugin_slug, $license_user, $license_key);
	}
}
add_action('init', 'download_from_files_617_update');



function download_from_files_617_get_options() { 

	$defaults = array(
            'template'        => 'default',  
            'folders'         => '1',
			'accept'          => 'doc,docx,odt,pdf,xls,xlsx,ods,zip',
            'disabled'        => '',  
			'sort_folders'    => 'set',
			'sort_files'      => 'set',
			'sort_order'      => 'default',
			'hide_direct_url' => '1',
            'target'          => '',
            'empty_text'      => __('This folder is empty.', 'download-from-files'),
            'rename'          => '1'    
		);

	$options = get_option('download_from_files_options');
	$options = wp_parse_args($options, $defaults);

    if (!empty($options['disabled'])) {
        if (!is_array($options['disabled'])) {
            $options['disabled'] = str_replace(' ', '', $options['disabled']);
            $options['disabled'] = explode(',', $options['disabled']);
        }
        if (!in_array('wp-admin', $options['disabled'])) {
            $options['disabled'][] = 'wp-admin';
        }
        if (!in_array('wp-includes', $options['disabled'])) {
            $options['disabled'][] = 'wp-includes';
        }
    } else {
        $options['disabled'] = array('wp-admin', 'wp-includes');
    }

	return $options;
}


function download_from_files_617_load_textdomain() {
    load_plugin_textdomain( 'download-from-files', false, basename( dirname( __file__ ) ) . '/languages' ); 
}
add_action( 'plugins_loaded', 'download_from_files_617_load_textdomain' );

function download_from_files_617_notices() {
    if( get_transient( 'download_from_files_617_activation_notice' ) ) {

        echo '<div class="notice notice-success"><p>' . __('Activation notice', 'download-from-files') . '</p></div>';
        delete_transient( 'download_from_files_617_activation_notice' );
    }
    if( get_transient( 'download_from_files_617_upgrade_notice' ) ) {
        echo '<div class="notice notice-success"><p>' . get_transient( 'download_from_files_617_upgrade_notice' ) . '</p></div>';
        delete_transient( 'download_from_files_617_upgrade_notice' );
    }
}
add_action( 'admin_notices', 'download_from_files_617_notices' );


function download_from_files_617_activation() {

	$options = download_from_files_617_get_options();
	update_option('download_from_files_options', $options, true);
    
    add_action( 'admin_notices', 'download_from_files_617_activation_notice' );
    set_transient( 'download_from_files_617_activation_notice', 1 );
    
}
register_activation_hook( __file__, 'download_from_files_617_activation' );

function download_from_files_617_deactivation() {

	delete_option('download_from_files_options');
}
register_deactivation_hook( __file__, 'download_from_files_617_deactivation' );

function download_from_files_617_uninstall() {

    delete_option('download_from_files_options');

}
register_uninstall_hook( __file__, 'download_from_files_617_uninstall' );

function download_from_files_617_shortcode($args) {

    $shortcode = '';
    if (WP_DEBUG) {
        $shortcode = array();
        foreach ($args as $key => $value) {
            $shortcode[] = $key.'="'.$value.'"';
        }
        $shortcode = '<!-- [download-from-files '.implode(' ', $shortcode).'] -->';
    }

	if (!isset($args['target']) or (empty($args['target']))) {
        return '';	   
	}
    
	$options = download_from_files_617_get_options();
    $disabled = $options['disabled'];
    unset($options['disabled']);
    
    $args = wp_parse_args($args, $options);
    if (substr($args['target'], -1) == DS) {
        $args['target'] = substr($args['target'], 0, -1);
    }

    if ((!isset($args['disabled'])) or (empty($args['disabled']))) {
        $args['disabled'] = $disabled;
    } else {
        $args['disabled'] = str_replace(' ', '', $args['disabled']);
        $args['disabled'] = explode(',', $args['disabled']);
        foreach ($disabled as $item) {
            if (!in_array($item, $args['disabled'])) {
                $args['disabled'][] = $item;
            }
        }
    }

	if (!defined('DOWNLOAD_FROM_FILES_617')) {
		download_from_files_617_styles_and_scripts_to_frontend();
	}
    if (!class_exists('JDownloadFromFiles617')) {
        include_once( dirname(__file__) .DS. 'libs' .DS. 'class.php');
    }

    $my_plugin = new JDownloadFromFiles617($args);

    $html = $shortcode . $my_plugin->prepareContent();
    if (!is_file(DOWNLOAD_FROM_FILES_617_WP_ROOT . $args['target'])) {
        $html = '<div class="dowload-from-files-block">'.$html.'</div>';
    }
    
    return $html;
}
add_shortcode('download-from-files', 'download_from_files_617_shortcode');

function download_from_files_617_get_from_tree($args) {

	if (!isset($args['target']) or (empty($args['target']))) {
        return '';	   
	}

    $shortcode = '';
    if (WP_DEBUG) {
        $shortcode = array();
        foreach ($args as $key => $value) {
            $shortcode[] = $key.'="'.$value.'"';
        }
        $shortcode = '<!-- [download-from-tree '.implode(' ', $shortcode).'] -->';
    }
    
	$options = download_from_files_617_get_options();
    $disabled = $options['disabled'];
    unset($options['disabled']);
    
    $args = wp_parse_args($args, $options);
    if (substr($args['target'], -1) == DS) {
        $args['target'] = substr($args['target'], 0, -1);
    }
    if ((!isset($args['disabled'])) or (empty($args['disabled']))) {
        $args['disabled'] = $disabled;
    } else {
        $args['disabled'] = str_replace(' ', '', $args['disabled']);
        $args['disabled'] = explode(',', $args['disabled']);
        foreach ($disabled as $item) {
            if (!in_array($item, $args['disabled'])) {
                $args['disabled'][] = $item;
            }
        }
    }

    include_once( dirname(__file__) .DS. 'libs' .DS. 'tree.php');
    $my_plugin = new JDownloadFromTree617($args);

    $html = $shortcode . $my_plugin->prepareContent();

    $html = '<div class="dowload-from-files-block">'.$html.'</div>';

    return $html;
}
add_shortcode('download-from-tree', 'download_from_files_617_get_from_tree');

function download_from_files_617_styles_and_scripts_to_frontend()
{
    global $pagenow;

    define('DOWNLOAD_FROM_FILES_617', 1);

    if (in_array( $pagenow, array( 'post.php', 'page.php', 'index.php' ))) {

        // wp_register_style( 'download-from-files', plugins_url( 'assets/css/download-from-files.css', __file__ ), array(), DOWNLOAD_FROM_FILES_617_VERSION );
    	// wp_enqueue_style( 'download-from-files' );
        
    	wp_register_script('download-from-files-js', plugins_url( 'assets/js/download-from-files.js', __file__ ), array('jquery'), DOWNLOAD_FROM_FILES_617_VERSION, true);

		wp_localize_script('download-from-files-js', 'download_from_files_617_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		wp_enqueue_script('download-from-files-js');
    }
}

function download_from_files_617_download_file()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
       $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $filename = $data['file'];
    if (!isset($data['no_encode'])) {
        $filename = base64_decode($data['file']);
    }
    
    if (!file_exists(DOWNLOAD_FROM_FILES_617_WP_ROOT . $filename)) {
        $result = array(
            'status' => 0,
            'error'  => sprintf( __('This file not exists! (%s)', 'download-from-file'), basename(DOWNLOAD_FROM_FILES_617_WP_ROOT . $filename) )
        );
        echo json_encode($result);
        wp_die();
    }
    $file = file_get_contents(DOWNLOAD_FROM_FILES_617_WP_ROOT . $filename);

    
    $result = array(
        'status'   => 1,
        'link'     => esc_url( home_url( '/' ) ). $filename,
        'filename' => basename(DOWNLOAD_FROM_FILES_617_WP_ROOT . $filename),
        'type'     => pathinfo(DOWNLOAD_FROM_FILES_617_WP_ROOT . $filename, PATHINFO_EXTENSION),
        'file'     => base64_encode($file)
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_download_from_files_617_download_file', 'download_from_files_617_download_file' );
add_action( 'wp_ajax_download_from_files_617_download_file', 'download_from_files_617_download_file' );

if ( is_admin() ){ 

    global $pagenow;

    if (in_array($pagenow, array('post.php', 'post-new.php'))) {
        if ( in_array( 'classic-editor/classic-editor.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ) {
            include_once( dirname(__file__) .DIRECTORY_SEPARATOR. 'libs' .DIRECTORY_SEPARATOR. 'insert-button.php');
        }
    }

    include_once( dirname(__file__) .DS. 'libs' .DS. 'admin-functions.php');
    include( dirname(__file__) .DS. 'libs' .DS. 'download-from-files-setup.php' );
    $my_settings_page = new download_from_files_617_settings();

    function download_from_files_617_get_extra_meta_links($meta, $file, $data, $status) {

        if (plugin_basename(__FILE__) == $file) {
            $lang = get_bloginfo('language');
            if ($lang == 'hu') {
                $url = 'http://wpdemo.dovi42.hu/download-from-files';
            } else {
                $url = 'http://wpdemo.dovi42.hu/download-from-files-en';
            } 
            $meta[] = "<a href='".$url."' target='_blank' title='" . __('Detailed description and examples', 'download-from-files') . "'>".__('Detailed description and examples', 'download-from-files')."</a>";

            $meta[]  = '<a href="https://wordpress.org/support/plugin/download-from-files/reviews/">'.
                       __('Please rating!', 'download-from-files') . '&nbsp;' .
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '<span class="dashicons dashicons-star-empty dashicons-star-filled" style="color:#ffb900 !important;"></span>'.
                       '</a>';
        }
        return $meta;
    }
    add_filter("plugin_row_meta", 'download_from_files_617_get_extra_meta_links', 10, 4);
    
}

function download_from_files_617_add_custom_link_into_appearnace_menu() {
    global $submenu;
    $permalink = 'options-general.php?page=download-from-files-setting-admin';
    $submenu['upload.php'][] = array( __('Downloaded files', 'download-from-files'), 'manage_options', $permalink );
}
add_action('admin_menu', 'download_from_files_617_add_custom_link_into_appearnace_menu');


function download_from_files_617_add_settings_link( $links ) {
    $settings_link = '<a href="options-general.php?page=download-from-files-setting-admin">' . __( 'Settings' ) . '</a>';
    array_unshift( $links, $settings_link );
  	return $links;
}
$plugin = plugin_basename( __file__ );
add_filter( "plugin_action_links_$plugin", 'download_from_files_617_add_settings_link' );

function download_from_files_617_styles_and_scripts_to_backend()
{
    global $pagenow;
    
    if (isset($_REQUEST['page'])) {
        $page = sanitize_text_field($_REQUEST['page']);
    } else {
        $page = '';
    }
    if (($pagenow == 'options-general.php') and ($page == 'download-from-files-setting-admin')) {

        $tab = 'files';
        if (isset($_REQUEST['download-from-files-tab'])) { $tab = sanitize_text_field($_REQUEST['download-from-files-tab']); }
        if ($tab == 'files') {
            wp_enqueue_script('jquery-ui-sortable', '', array('jquery'), DOWNLOAD_FROM_FILES_617_VERSION);
        }


        wp_register_style( 'download-from-files-admin', plugins_url( 'assets/css/download-from-files-admin.css', __file__ ), array(), DOWNLOAD_FROM_FILES_617_VERSION );
    	wp_enqueue_style( 'download-from-files-admin' );
        
    	wp_register_script('download-from-files-admin-js', plugins_url( 'assets/js/download-from-files-admin.js', __file__ ), array('jquery-ui-sortable'), DOWNLOAD_FROM_FILES_617_VERSION);

		wp_localize_script('download-from-files-admin-js', 'download_from_files_617_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
		$options = download_from_files_617_get_options();
		$ajax_vars = array(
				'accept' => $options['accept'],
				'sort_folders' => $options['sort_folders'],
				'sort_files' => $options['sort_files'],
				'hide_direct_url' => $options['hide_direct_url']
			);
		wp_localize_script('download-from-files-admin-js', 'download_from_files_ajax_vars', $ajax_vars);
        
        $download_lang = array(
                'NEW_FOLDER_LABEL'      => __('New folder name:', 'download-from-files'),
                'EDIT_TITLE_LABEL'      => __('Folder new name:', 'download-from-files'),
                'NEED_SELECTED_FILES'   => __('Is function need selected files!', 'download-from-files'),
                'ADD'                   => __('Add'),
                'RENAME'                => __('Rename', 'download-from-files'),
                'SELECTED_FILES_TITLE'  => __('Selected files title:', 'download-from-files'),
                'EDIT_FILE_TITLE'       => __('File name:', 'download-from-files'),
            );
		wp_register_script('download-from-files-admin-js', '', array('jquery'), DOWNLOAD_FROM_FILES_617_VERSION, true);
		wp_localize_script('download-from-files-admin-js', 'download_lang', $download_lang);
		wp_enqueue_script('download-from-files-admin-js');
    }
}
add_action( 'admin_enqueue_scripts', 'download_from_files_617_styles_and_scripts_to_backend' );

function download_from_files_617_refresh()
{
    $token = '';
    if (isset($_REQUEST['token'])) {
        $token = sanitize_text_field($_REQUEST['token']);
    }

    $target = '';
    if (isset($_REQUEST['target'])) {
        $target = sanitize_text_field($_REQUEST['target']);
    }

    $update = '';
    if (isset($_REQUEST['update'])) {
        $update = sanitize_text_field($_REQUEST['update']);
    }
    
    $options = '';
    if (isset($_REQUEST['options'])) {
        $options = sanitize_text_field($_REQUEST['options']);
        $options = json_decode( base64_decode($options), true);
    }

    if ((empty($token)) or (empty($options))) {
        $result = array(
            'status' => 0,
            'error'  => __('Variables is empty!', 'download-from-files')
        );
        echo json_encode($result);
        wp_die();
    }

    if (!empty($target)) {
        if ($update == 1) {
            $options['target'] = $target;
        } else {
            if ($target != '..') {
                $options['target'] .= '/'.$target;
            } else {
                $target = explode(DIRECTORY_SEPARATOR, $options['target']);
                unset($target[count($target)-1]);
                $options['target'] = implode(DIRECTORY_SEPARATOR, $target);
            }
        }
    }

    download_from_files_617_include('/libs/hooks.php');

    if (!class_exists('JDownloadFromFiles617')) {
        include_once( dirname(__file__) .DS. 'libs' .DS. 'class.php');
    }

    $my_plugin = new JDownloadFromFiles617($options);
    $html = $my_plugin->prepareContent($options);
    
    $result = array(
        'status'   => 1,
        'token'    => $token,
        'html'     => $html
    );
    echo json_encode($result);
    wp_die();

}
add_action( 'wp_ajax_nopriv_download_from_files_617_refresh', 'download_from_files_617_refresh' );
add_action( 'wp_ajax_download_from_files_617_refresh', 'download_from_files_617_refresh' );




function download_from_files_617_include($filename) {
    if (file_exists(DOWNLOAD_FROM_FILES_617_ROOT . $filename)) {
        include_once(DOWNLOAD_FROM_FILES_617_ROOT . $filename);
    }
} 

if ( !is_admin() ) {
    download_from_files_617_include('/libs/hooks.php');
}
