<?php

    if (!defined('DS')) {
        define( 'DS', DIRECTORY_SEPARATOR );
    }

function download_from_files_617_getIcon($ext)
{
    $icon = '';
    
    switch ($ext){ 
    	case 'exe':
    	   $icon = 'exe.png';
           break;

    	case 'doc':
    	case 'docx':
    	case 'odt':
    	   $icon = 'doc.png';
           break;

    	case 'xls':
    	case 'xlsx':
    	case 'ods':
    	case 'xml':
    	case 'csv':
    	   $icon = 'xls.png';
           break;

    	case 'ppt':
    	case 'pptx':
    	   $icon = 'ppt.png';
           break;

    	case 'sql':
    	case 'dump':
    	   $icon = 'sql.png';
     	   break;

    	case 'zip':
    	case 'rar':
    	case 'arj':
    	case 'tgz':
    	   $icon = 'package.png';
           break;
    
    	case 'txt':
    	   $icon = 'text.png';
           break;
    
    	case 'pdf':
    	   $icon = 'pdf.png';
           break;

    	case 'gif':
    	case 'jpg':
    	case 'png':
    	   $icon = 'img.png';
           break;


    	default :
            $icon = 'file.png';
    }            
    
    $icon = plugins_url( 'download-from-files/assets/images/', DOWNLOAD_FROM_FILES_617_ROOT) . $icon;
    return $icon;
}

function download_from_files_617_getUpFolder($path, $options) 
{
    
    $path = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $path);
    if (empty($path)) { return ''; }

    $path = explode(DS, $path);

    unset($path[count($path)-1]);
    $path = implode('|', $path);
    
    $html = '<div class="download-from-files-folder-thumb">' . "\r\n";
    $html .= '<div class="download-from-files-jslink" ondblclick="download_from_files_617_setViewPath(\''.$path.'\');">' . "\r\n";
    $html .= '<img src="'.plugins_url( 'download-from-files/assets/images/up.png', DOWNLOAD_FROM_FILES_617_ROOT).'" />' . "\r\n";
    $html .= '</div>' . "\r\n";
    $html .= '<div class="download-from-files-thumbnail-title">' . __('Directory up', 'download-from-files') . '</div>' . "\r\n";
    $html .= '</div>' . "\r\n";

    return '<li data-filename="[up]" class="sort-disabled aligned">' . $html . '</li>';
}

function download_from_files_617_getFolder($item, $path, $options, $writeable = 1) 
{
   
    if ($item['title'] == $item['name']) {
        $title = '[' . $item['title'] . ']';
    } else {
        $title = $item['title'];
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }

    $info = new JDovi42Files($path .DS. $item['name']);
    
    $folders = $info->getFolders();
    $files = $info->getFiles();

    $count = 0;
    if (!empty($folders)) { $count += count($folders); }
    if (!empty($files)) { $count += count($files); }

    $path = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $path);
    if (!empty($path)) {
        $path = explode(DS, $path);
    } else {
        $path = array();
    }
    
    $path[] = $item['filename'];
    $path = implode('|', $path);

    if (substr($path, 0, 1) == DS) {
        $path = substr($path, 1);
    }

    $delete = ''; $edit = '';
    if ($writeable) {
        if ($count < 1) {
            $delete = '<div class="delete_folder_icon download-from-files-function-icon icon-left" onclick="download_from_files_617_deleteFolder(jQuery(this));" title="'.__('Delete item','download-from-files').'"><span class="dashicons dashicons-trash"></span></div>';
        }
        $edit   = '<div class="edit_folder_icon download-from-files-function-icon icon-right" onclick="download_from_files_617_edit_folder_box(jQuery(this));" title="'.__('Edit item title','download-from-files').'"><span class="dashicons dashicons-admin-comments"></span></div>';
    }
    
    $thumbnail = '';
    if (isset($item['thumbnail'])) {
        $thumbnail = '<img class="download-from-files-folder-thumbnail" src="'.esc_url( home_url( '/' ) ) . $path .DS. $item['thumbnail'].'" style="max-width: '.($size[0]/2).'px;max-height: '.($size[1]/2).'px;" />' . "\r\n";
    }
    
    $bar = '';
    
    $html  = '<li id="folder_'.$item['name'].'" class="ui-state-default aligned" data-filename="'.$item['filename'].'" data-path="'.$path.'">' . "\r\n";
    $html .= '  <div class="download-from-files-folder-thumb">' . "\r\n";
    $html .= '      <div class="download-from-files-jslink" ondblclick="download_from_files_617_setViewPath(\''.$path.'\');" title="'.__('Double click to open folder!','download-from-files').'">' . "\r\n";
    $html .= '          <img src="'.plugins_url( 'download-from-files/assets/images/empty-folder.png', DOWNLOAD_FROM_FILES_617_ROOT).'" />' . "\r\n";
    $html .= $thumbnail; 
    $html .= '      </div>' . "\r\n"; 
    $html .= '      <div class="download-from-files-item-functions-bar">' . "\r\n";
    $html .= $delete . $edit . "\r\n";
    $html .= '      </div>' . "\r\n";
    $html .= '      <div style="clear:both;"></div>' . "\r\n";
    $html .= '      <div class="download-from-files-thumbnail-title">' . $title . '</div>' . "\r\n";
    $html .= '  </div>' . "\r\n";
    $html .= '</li>' . "\r\n";
    return $html;
}

function download_from_files_617_getFiles($item, $path, $options, $index, $writeable) 
{

    if ($item['title'] == $item['filename']) {
        $title = '[' . $item['name'] . ']';
    } else {
        $title = $item['title'];
    }
    
    $path = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $path);
    
    $url  = home_url() .DS. $path .DS. $item['filename'];
    $icon = download_from_files_617_getIcon($item['ext']);
    
    $edit = ''; $select = '';
    if ($writeable) {
        $edit   = '<div class="edit_folder_icon download-from-files-function-icon icon-right" onclick="download_from_files_617_edit_image_box(jQuery(this));" title="'.__('Edit item title','download-from-files').'"><span class="dashicons dashicons-admin-comments"></span></div>';
        $select = '<div class="select-icon download-from-files-function-icon icon-left"><input type="checkbox" class="file-select" /></div>';
    }
    $shortcode = '<div class="shortcode-icon download-from-files-function-icon icon-left" onclick="download_from_files_617_copy_file_to_clipboard(jQuery(this));" style="display:inline-block;cursor:pointer;"><span class="dashicons dashicons-shortcode" title="'.__('Copy shortcode to clipboard', 'download-from-files').'"></span></div>';
    
    $ext = '';
    if ($item['ext'] != '') {
        $ext = strtoupper($item['ext']) . ', ';
    }
    
    $html  = '<li id="file_'.$item['name'].$index.'" class="ui-state-default aligned" data-filename="'.$item['filename'].'">' . "\r\n";
    $html .= '  <div class="download-from-files-folder-thumb">' . "\r\n";
    $html .= '      <div>' . "\r\n";
    $html .= '          <a class="download-link" href="'.$url.'" target="_blank">' . "\r\n";    
    $html .= '              <img class="thumbnail-link" src="'.$icon.'" />' . "\r\n";
    $html .= '          </a>' . "\r\n";
    $html .= '      </div>';
    $html .= '      <div class="download-from-files-item-functions-bar">' . "\r\n";
    $html .= $select . $shortcode . $edit . "\r\n";
    $html .= '      </div>' . "\r\n";
    $html .= '      <div style="clear:both;"></div>' . "\r\n";
    $html .= '      <div class="download-from-files-thumbnail-title">' . $title . '</div>' . "\r\n";
    $html .= '      <div class="download-from-files-thumbnail-info">(' . $ext . $item['size_text'].')</div>' . "\r\n";
    $html .= '  </div>' . "\r\n";
    $html .= '</li>' . "\r\n";
    return $html;
}



function download_from_files_617_sort_reorder() {

    if (!isset($_REQUEST['path'])) {
        $data = array(
            'status' => 0,
            'message' => __('Path not set!', 'download-from-files')
        );
        echo json_encode($data);          
        wp_die();
    }
    
    $path  = sanitize_text_field($_REQUEST['path']);

    $order = sanitize_text_field($_REQUEST['order']);
    $order = json_decode(stripslashes($order));
    $order = implode("\r\n", $order);
    $ok = file_put_contents($path .DS. 'filesort.txt', $order); 
    
    $message = '';
    if ($ok !== false) {
        $status = 1;
        @chmod($path .DS. 'filesort.txt', 0664);
    } else {
        $status = 0;
        $message = __('Error in file creation!', 'download-from-files');
    }

    $data = array(
        'status'   => $status,
        'message'  => $message
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_download_from_files_617_sort_reorder', 'download_from_files_617_sort_reorder' );
add_action( 'wp_ajax_download_from_files_617_sort_reorder', 'download_from_files_617_sort_reorder' );

function download_from_files_617_new_folder()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);
    $alias = $folder->getAlias($data['title']);
    $alias = $folder->getEmptyName($alias);
    
    $item = $folder->newFolder($alias, $data['title']);
    
    if ($item) {
        $options = download_from_files_617_get_options();
        $path = str_replace(DS.DS, DS, $data['path']);
        $path = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $path);
        $html = download_from_files_617_getFolder($item, $path, $options); 

        $data = array(
            'status' => 1,
            'html'   => $html
        );
    } else {
        $data = array(
            'status'  => 0,
            'message' => __('Folder creation error.', 'gallery-from-file') . '('.str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $data['path']).$alias.')'
        );
    }
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_download_from_files_617_new_folder', 'download_from_files_617_new_folder' );
add_action( 'wp_ajax_download_from_files_617_new_folder', 'download_from_files_617_new_folder' );

function download_from_files_617_delete_folder()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);

    if ($folder->deleteFolder($data['filename'])) {
        $data = array(
            'status' => 1,
            'id'     => $data['id']
        );
    } else {
        $data = array(
            'status'  => 0,
            'id'     => $data['id'],
            'message' => __('Folder delete error.', 'gallery-from-file') . '('.str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $data['path']).$alias.')'
        );
    }
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_download_from_files_617_delete_folder', 'download_from_files_617_delete_folder' );
add_action( 'wp_ajax_download_from_files_617_delete_folder', 'download_from_files_617_delete_folder' );

function download_from_files_617_js_edit_folder()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);
    $options = download_from_files_617_get_options();
    if ($options['rename'] != 0) {
        $filename = $folder->rename($data['filename'], $data['title']);
    } else {
        $filename = $data['filename'];
        $folder->updateDescription($filename, stripslashes($data['title']));
    }

    $data = array(
        'status' => 1,
        'id'     => $data['id'],
        'filename' => $filename,
        'title'    => stripslashes($data['title'])
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_download_from_files_617_js_edit_folder', 'download_from_files_617_js_edit_folder' );
add_action( 'wp_ajax_download_from_files_617_js_edit_folder', 'download_from_files_617_js_edit_folder' );


function download_from_files_617_edit_description()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $folder = new JDovi42Files($data['path']);
    $options = download_from_files_617_get_options();
    if ($options['rename'] != 0) {
        $filename = $folder->rename($data['filename'], $data['title']);
    } else {
        $filename = $data['filename'];
        $folder->updateDescription($filename, stripslashes($data['title']));
    }

    $data = array(
        'status'   => 1,
        'id'       => $data['id'],
        'filename' => $filename,
        'title'    => $data['title']
    );
    echo json_encode($data);          
    wp_die();
    
}
add_action( 'wp_ajax_nopriv_download_from_files_617_edit_description', 'download_from_files_617_edit_description' );
add_action( 'wp_ajax_download_from_files_617_edit_description', 'download_from_files_617_edit_description' );


function download_from_files_617_delete_file()
{

    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }
    $options = download_from_files_617_get_options();

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $path = new JDovi42Files($data['path']);
    $path->deleteFile($data['filename']);
     
    $data = array(
        'status'    => 1,
        'id'        => $data['id']
    );
    echo json_encode($data);          
    wp_die();
}
add_action( 'wp_ajax_nopriv_download_from_files_617_delete_file', 'download_from_files_617_delete_file' );
add_action( 'wp_ajax_download_from_files_617_delete_file', 'download_from_files_617_delete_file' );


function download_from_files_617_getAlias($text)
{
        $str = trim(mb_strtolower($text, 'UTF-8'));

        $accented = array( "á", "é", "í", "ó", "ö", "ő", "ú", "ü", "ű" );  
        $mask     = array( "a", "e", "i", "o", "o", "o", "u", "u", "u" );  
        $str = str_replace( $accented, $mask, $str );  

        $str = str_replace('-', ' ', $str);
        $str = str_replace('_', ' ', $str);
        $str = preg_replace(array('/\s+/','/[^A-Za-z0-9\-|+.]/'), array('-',''), $str);
        
        return $str;
}


function download_from_files_617_fileupload()
{
    $data = array();
    foreach ($_REQUEST as $key => $value) {
        $data[sanitize_text_field($key)] = sanitize_text_field($value);
    }

    $name     = $data['filesName'];
    // ! Sanitize in 453. line !
    $files    = $_FILES[$name];

    // Allowed extensions
    if (!isset($data['allowExt'])) {
        $options = download_from_files_617_get_options();
        $allowExt = explode(',', $options['accept']);
    } else {
        $allowExt = explode(',', $data['allowExt']);
    }
    // Disable extensions
    $allowExt = array_diff($allowExt, array('php', 'php4', 'phtml', 'htm', 'html', 'js'));
 
    // Allowed size
    $maxSize  = $data['maxSize']; // *1000 
    if ($maxSize == null) { $maxSize = 0; }

    $target_dir = $data['uploadDir'];
    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DS. 'jdovi42_files.php');
    }
    $target = new JDovi42Files($target_dir);
    $target->checkFolder($target_dir);
    
    for ($i = 0; $i <= count($files['name'])-1; $i++) {
        
        $error = array();
        
        $name = download_from_files_617_getAlias($files['name'][$i]);
        $name = sanitize_text_field($name);
        
        setlocale(LC_ALL,'en_US.UTF-8');
        $path_parts = pathinfo($name);
        $ext  = strtolower(trim($path_parts['extension']));
        $name = $path_parts['filename'];
        $size = $files['size'][$i];

        // Ha nincs megadva fájl.
        if (empty($name)) {
            $error[] = __('File not set.', 'download-from-files');
        } 
        
        // Ha a fájl típusa nem megfelelő
        if (($allowExt != null) and (!in_array($ext, $allowExt))) {
            $error[] = __('File type not allowed.', 'download-from-files');
        }
        
        // Ha a fájl mérete nem megfelelő
        if (($maxSize != 0) and ($size > ($maxSize * 1000))) {
            $error[] = __('Files size too big.', 'download-from-files');
        }

        // Szerveroldali hibák
        switch($files['error'][$i])
		{
			case '1':
				$error[] = __('The uploaded file exceeds the upload_max_filesize directive in php.ini', 'download-from-files');
				break;
			case '2':
				$error[] = __('The uploaded file exceeds the MAX_FILE_SIZE directive that was specified in the HTML form', 'download-from-files');
				break;
			case '3':
				$error[] = __('The uploaded file was only partially uploaded', 'download-from-files');
				break;
			case '4':
				$error[] = __('No file was uploaded.', 'download-from-files');
				break;
			case '6':
				$error[] = __('Missing a temporary folder', 'download-from-files');
				break;
			case '7':
				$error[] = __('Failed to write file to disk', 'download-from-files');
				break;
			case '8':
				$error[] = __('File upload stopped by extension', 'download-from-files');
				break;
			case '999':
			default:

		}

        if (empty($target_dir)) {
            $error[] = __('Not set target folder.', 'download-from-files');
        }

        if (empty($error)) {
            
            $name = $target->getAlias($name);
            $name = $target->getEmptyName($name . '.' . $ext);

            $inFile  = $files['tmp_name'][$i];
            $outFile = $target_dir .DS. $name;

			if (!move_uploaded_file($inFile, $outFile)) {
				$error[] = "Nem sikerült a fájlok átmozgatása!" . "(" . $outFile . ')';
            } else {
                @chmod($outFile, 0664);
            }
			@unlink($inFile);	
        }
    }

    if (empty($error)) {
        // $error = 'A fájl sikeresen feltöltve.';
        $data = array(
            'status' => 1,
            'message' => 'Sikeres a fájl(ok) másolása.'
        );
        echo json_encode($data);          
    } else {
        $result[] = '<div>'.$name. ' : ' . '<span style="color: red;">Hiba</span> : ' . implode(', ', $error) . '</div>';
        $data = array(
            'status' => 0,
            'message' => implode('', $result)
        );
        echo json_encode($data);          
    }
    wp_die();
}
// Disable in frontend
//add_action( 'wp_ajax_nopriv_download_from_files_617_fileupload', 'download_from_files_617_fileupload' );
add_action( 'wp_ajax_download_from_files_617_fileupload', 'download_from_files_617_fileupload' );
