<?php

if (!defined('DS')) { define( 'DS', DIRECTORY_SEPARATOR ); }

class JDownloadsFromFiles extends stdClass
{
    private $options = array();
    private $path = '';
    private $folders = array();
    private $files = array();
    private $is_writeable = false;
    
    public function __construct($options)
	{
        $this->options = $options;	   
        $this->path = DOWNLOAD_FROM_FILES_617_WP_ROOT;
        
        if (isset($_REQUEST['download-from-files-path'])) {
            $this->path .= sanitize_text_field($_REQUEST['download-from-files-path']); 
        } else  {
            if (isset($_COOKIE['download-from-files-path'])) {
                $this->path .= sanitize_text_field($_COOKIE['download-from-files-path']); 
            }
        }
        $this->path = str_replace('|', DIRECTORY_SEPARATOR, $this->path);
        
    }

    function checkWriteable() {
        
        if (is_writeable($this->path)) {
            $this->is_writeable = true;
        } else {
            $this->is_writeable = false;
            $path = str_replace(GALLERY_FROM_FILES_595_WP_ROOT, '', $this->path);
            echo '<div class="notice notice-error">'.
                 '<p>' . sprintf( __('This folder not writeable! <em>(%s)</em>', 'download-from-files'), $path) . '</p>'.
                 '</div>';
        }
        
    }


    function getRouter()
    {
        $route = array();

        $path = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $this->path);
        if (!empty($path)) { 
            $path = explode(DS, $path);
        }
        $route[] = '<span class="route-item" onclick="download_from_files_617_setViewPath(\'\');">' . __('Home', 'download-from-files') . '</span>';
        
        if (!empty($path)) {
            if (!class_exists ('JDovi42Files', false)) {
                include_once(dirname(__file__) .DS. 'jdovi42_files.php');
            }
            $p = array();
            foreach ($path as $item) {
                $tmp = new JDovi42Files(DOWNLOAD_FROM_FILES_617_WP_ROOT . implode(DS, $p));
                $title = $tmp->getTitle($item);

                $p[] = $item;
                $route[] = '<span class="route-item" onclick="download_from_files_617_setViewPath(\''.implode(DS, $p).'\');">' . $title. '</span>';
            }
            
        }
        $route = __('Folder path', 'download-from-files') . ': ' . implode(' -> ', $route);
        return '<div class="gallery-route">' . $route . '</div>';
    }

    function getShortcode() {
        
        $folder = str_replace(DOWNLOAD_FROM_FILES_617_WP_ROOT, '', $this->path);
        $folder = str_replace(DIRECTORY_SEPARATOR, '/', $folder);
        
        $html = '<div class="shortcode" data-folder="'.$folder.'" style="display:inline-block;float:left;padding-top:6px;">';
        
        if (!class_exists('JDovi42Files')) {
            include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
        }
        $folders = array('tree' => __('Tree template', 'download-from-files'));

        $text = __('Default template', 'download-from-files');
        $text = __('Extended template', 'download-from-files');
        $text = __('Browse template', 'download-from-files');

        $source = new JDovi42Files(get_stylesheet_directory() . '/download-from-files');
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	$folders[$tmp[$i]['filename']] = __($tmp[$i]['title'], 'download-from-files'); 
            }
        }

        $source = new JDovi42Files(DOWNLOAD_FROM_FILES_617_ROOT . '/templates'); 
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	if (!isset($folders[$tmp[$i]['filename']])) {
                    $folders[$tmp[$i]['filename']] = __($tmp[$i]['title'], 'download-from-files'); 
            	}
            }
        }
        ksort($folders);

        $template_selector = '<select onchange="download_from_files_change_template();" name="template" id="template_selector">' .
                             '<option value="">' . __('Select template', 'download-from-files') . '</option>';
        foreach ($folders as $key => $value) {
            $template_selector .= '<option value="'.$key.'">' . $value . '</option>';
        }                             
        $template_selector .= '</select>';

        $html .= 'Shortcode: <span class="code">[download-from-files target="'.$folder.'"]</span>' .
                 $template_selector.
                 '<button onclick="download_from_files_617_copy_to_clipboard();" type="button" class="button" style="margin-left:6px;" title="'.__('Copy shortcode to clipboard', 'download-from-files').'">'.
                 '<span class="dashicons dashicons-shortcode" style="margin-right:0;"></span>'.
                 '</button>';
        
        $html .= '</div>';
        return $html;
    }

    function getTopBar()
    {
        $html = '<div class="functions-bar">' . "\r\n" .
                $this->getRouter() . "\r\n" . 
                $this->getShortcode() . "\r\n";

        if ($this->is_writeable) {
                
            $html .= "\t" . '<div style="display: inline-block;float:right;">' . "\r\n" .
                     "\t\t" . '<button onclick="download_from_files_617_new_folder_box();" type="button" class="button button-secondary"><span id="add_new_folder_icon" class="dashicons dashicons-plus" style="margin-top:5px;"></span>&nbsp;'. __('Add new folder', 'download-from-files').'</button>' . "\r\n" .
                     "\t" . '</div>' . "\r\n";
        }
        
        $html .= "\t" . '<div style="clear:both"></div>' . "\r\n" .
                 '</div>';
        
        return $html;
    }

    function getContent()
    {
        if (!class_exists ('JDovi42Files', false)) {
            include_once(dirname(__file__) .DS. 'jdovi42_files.php');
        }

        $path = new JDovi42Files($this->path);
        $options = download_from_files_617_get_options();
        $path->addTilt($options['disabled']);

        if ((isset($this->options['accept'])) and ($this->options['accept'] != '')) {
            $path->allowExt = explode(',', $this->options['accept']);
        } 

        $this->folders = $path->getFolders();
        $this->files = $path->getFiles();

        $folders = array();
        if (!empty($this->folders)) {
            foreach ($this->folders as $item) {
                $folders[] = download_from_files_617_getFolder($item, $this->path, $this->options, $this->is_writeable);
            }
        }
        $folders = implode("\r\n", $folders);
        
        $files = array();
        if (!empty($this->files)) {
            $index = 1;
            foreach ($this->files as $item) {
                $files[] = download_from_files_617_getFiles($item, $this->path, $this->options, $index, $this->is_writeable);
                $index++;
            }
        }
        $files = implode("\r\n", $files);
        
        
        $html = "\r\n" . 
                '<div class="functions-bar">' . "\r\n" . 
                "\t" . '<div id="download-content">' . "\r\n" .
                "\t\t" . '<ul id="folders" class="sortable list-unstyled" data-path="'.$this->path.'">' .
                            download_from_files_617_getUpFolder($this->path, $this->options) . "\r\n" .
                            $folders . "\r\n" .
                "\t\t" . '</ul>' . "\r\n" .
                "\t\t" . '<ul id="files" class="sortable list-unstyled" data-path="'.$this->path.'">' .
                            $files . "\r\n" .
                "\t\t" . '</ul>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t" . '<div style="clear:both;"></div>' . "\r\n" .
                '</div>';
        
        return $html;
    }

    function getFunctionsBar() {

        if (!$this->is_writeable) {
            return '';
        }

        $html = '<div class="functions-bar">' . "\r\n" .
                "\t" . '<div style="display: inline-block;">' . "\r\n" .
                "\t\t" . '<button id="button_select_all" onclick="download_from_files_617_select_all();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t" . '<img src="'.plugins_url( 'download-from-files/assets/images/check.png', DOWNLOAD_FROM_FILES_617_ROOT).'" />' . "\r\n" .
                "\t\t\t" . __('Select all', 'download-from-files') . "\r\n" .
                "\t\t" . '</button>' . "\r\n" .
                "\t\t" . '<button id="button_unselect_all" onclick="download_from_files_617_unselect_all();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t" . '<img src="'.plugins_url( 'download-from-files/assets/images/uncheck.png', DOWNLOAD_FROM_FILES_617_ROOT).'" />' . "\r\n" .
                "\t\t\t" . __('Unselect all', 'download-from-files') . "\r\n" .
                "\t\t" . '</button>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t\t" . '<div style="float: right;border-left: 1px solid #ccc;margin-left:10px;padding-left:10px;">' . "\r\n" .
                "\t\t\t" . '<button id="button_delete_selected" onclick="download_from_files_617_selected_delete();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="group_delete_icon" class="dashicons dashicons-trash"></span>' . "\r\n" .
                "\t\t\t\t" . __('Delete', 'download-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t\t" . '<div style="float: right;">' . "\r\n" .
                "\t\t\t" . '<button id="button_rename_selected" onclick="download_from_files_617_groupTitles();" type="button" class="button button-secondary">' . "\r\n" .
                "\t\t\t\t" . '<span id="group_title_icon" class="dashicons dashicons-admin-comments"></span>' . "\r\n" .
                "\t\t\t\t" . __('Rename', 'download-from-files') . "\r\n" .
                "\t\t\t" . '</button>' . "\r\n";

        $html .= "\t" . '</div>' . "\r\n" .
                 "\t" . '<div style="clear: both;"></div>' . "\r\n" .
                 '</div>';
        return $html;
    }

    function getUploadBar() {

        if (!$this->is_writeable) {
            return '';
        }

        $allowed = '*';
        if (isset($this->options['accept'])) {
            $allowed = explode(',', $this->options['accept']);
            $allowed = '.' . implode(',.', $allowed);            
        }
        $html = '<div class="functions-bar">' . "\r\n" .
                "\t" . '<form id="files_upload" method="post" enctype="multipart/form-data">' . "\r\n" .
                "\t\t" . '<label for="myfile">'. __('Select files', 'download-from-files').':</label>' . "\r\n" .
                "\t\t" . '<input type="file" class="input" id="myfile" name="myfile[]" multiple="multiple" accept="'.$allowed.'"  />' . "\r\n" .
                "\t\t" . '<input type="submit" class="button button-secondary" value="'. __('Upload selected files', 'download-from-files').'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="action" value="download_from_files_617_fileupload" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="filesName" value="myfile" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="allowExt" value="'.$this->options['accept'].'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="maxSize" value="0" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="uploadDir" value="'.$this->path.'" />' . "\r\n" .
                "\t\t" . '<input type="hidden" name="size" value="0" />' . "\r\n";
        $html .= "\t" . '</form>' . "\r\n" .
                 "\t" . '<div id="err"></div>' . "\r\n" .
                 '</div>' . "\r\n";
        return $html;
    }

    function getGauge()
    {
        $html = '<div id="download-job-gauge">' . "\r\n" .
                "\t" . '<div class="wait-message" style="text-align: center;">'.__('Job process running...', 'download-from-files').'</div>' . "\r\n" .
                "\t" . '<div class="gauge-line" style="text-align: center;">' . "\r\n" .
                "\t\t" . '<div style="width: 206px;display:inline-block;border:1px solid #0071a1;padding:2px;">' . "\r\n" .
                "\t\t\t" . '<div class="gauge" style="float:left;height:16px;background-color:#0071a1;width:114px;"></div>' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                "\t" . '<div class="percent" style="text-align: center;">57%</div>' . "\r\n" .
                "\t" . '<div class="wait-image" style="text-align: center;">' . "\r\n" .
                "\t\t" . '<img src="'.plugins_url( 'download-from-files/assets/images/wait.gif', DOWNLOAD_FROM_FILES_617_ROOT).'" />' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                '</div>' . "\r\n" . 
                '<div id="download_get_name" style="display:none;">' . "\r\n" .
                '<form id="title_box" action="#">' . 
                "\t" . '<div style="text-align:left;">' . "\r\n" .
                "\t\t" . '<label class="download_get_title_label" for="download_get_title"></label>' . "\r\n" .
                "\t\t" . '<input id="download_get_title" type="text" value="" style="width:100%;" />' . "\r\n" .
                "\t\t" . '<hr />' . "\r\n" .
                "\t\t" . '<div class="message_functions" style="text-align:right">' . "\r\n" .
                "\t\t\t" . '<input onclick="download_from_files_617_hideTitleBox();" type="button" class="button button-secondary" value="'.__('Cancel').'" />' . "\r\n" .
                "\t\t" . '</div>' . "\r\n" .
                "\t" . '</div>' . "\r\n" .
                '</form>' . 
                '</div>' . "\r\n";
        return $html;
    }


    function render()
    {
        $html = '';
        $html .= $this->checkWriteable() .
                 $this->getTopBar() .
                 $this->getContent() . 
                 $this->getFunctionsBar() .
                 $this->getUploadBar().
                 $this->getGauge();
        
        echo $html;
    }
}