<?php
function include_download_from_files_617_media_button_js_file() {
    global $pagenow;
    $options = download_from_files_617_get_options();
    $options['url'] = plugins_url( 'download-from-files/assets/icons/', DOWNLOAD_FROM_FILES_617_ROOT );
    
    $pos = strpos($options['url'], '://');
    if ($pos !== false) {
        $options['url'] = substr($options['url'], ($pos + 1));
    }
    
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        wp_enqueue_style('dovi_download_admin_tree', plugins_url( 'download-from-files/assets/css/jstree.style.css', DOWNLOAD_FROM_FILES_617_ROOT), false, '1.0.0' );
        wp_enqueue_style('download-from-files-tree-css', plugins_url( 'download-from-files/assets/css/download-tree.css', DOWNLOAD_FROM_FILES_617_ROOT), false, DOWNLOAD_FROM_FILES_617_VERSION );
                
        wp_register_script('download-from-files-tree-js', plugins_url( 'download-from-files/assets/js/download-media-button.js', DOWNLOAD_FROM_FILES_617_ROOT ), array('jquery'), DOWNLOAD_FROM_FILES_617_VERSION, true);

        wp_enqueue_script('download-from-files-media-button-js', plugins_url( 'download-from-files/assets/js/jstree.js', DOWNLOAD_FROM_FILES_617_ROOT ), array('download-from-files-tree-js'), '1.0', true);
        wp_localize_script('download-from-files-media-button-js', 'download_from_files_options', $options);
        $plugin_data = array(
                'url'  => plugins_url( 'download-from-files/libs/load-folders.php', DOWNLOAD_FROM_FILES_617_ROOT ),
                'root' => DOWNLOAD_FROM_FILES_617_WP_ROOT
            );
        wp_localize_script('download-from-files-media-button-js', 'downloads_from_files_data', $plugin_data );
        wp_add_inline_script('download-from-files-media-button-js', 'var downloads_from_files_root = "'.DOWNLOAD_FROM_FILES_617_WP_ROOT.'";', 'before' );
        

    }
}
add_action('wp_enqueue_media', 'include_download_from_files_617_media_button_js_file');

function add_download_from_files_617_media_button() {
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {

        $html = '<a href="#TB_inline?&width=754&height=560&inlineId=download-from-files-tree-block" class="thickbox button" title="' .
                __( "Select download from folders to insert into post", "download-from-files" ) .
                '"><span class="wp-media-buttons-icon dashicons dashicons-images-alt2" style="margin-top:-3px;"></span> ' .
                __('File download', 'download-from-files') . '</a>';
        echo $html;
    }
}
add_filter('media_buttons', 'add_download_from_files_617_media_button');

function download_from_files_617_admin_footer()
{
    global $pagenow;
    if ( in_array( $pagenow, array( 'post.php', 'page.php', 'post-new.php', 'post-edit.php' ) ) ) {
        $options = download_from_files_617_get_options();
        
        $checked = '';
        if ($options['folders'] == 1) {
            $checked = 'checked="checked"';
        }

        $folders = array('tree' => __('Tree template', 'download-from-files'));

        $text = __('Default template', 'download-from-files');
        $text = __('Extended template', 'download-from-files');
        $text = __('Browse template', 'download-from-files');
        
        if (!class_exists('JDovi42Files')) {
            include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
        }

        $source = new JDovi42Files(get_stylesheet_directory() . '/download-from-files');
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	$folders[$tmp[$i]['filename']] = __($tmp[$i]['title'], 'download-from-files');; 
            }
        }

        $source = new JDovi42Files(DOWNLOAD_FROM_FILES_617_ROOT . '/templates'); 
        $tmp = $source->getFolders();        
        if (!empty($tmp)) {
            for ($i = 0; $i <= count($tmp)-1; $i++) {
            	if (!isset($folders[$tmp[$i]['filename']])) {
                    $folders[$tmp[$i]['filename']] = __($tmp[$i]['title'], 'download-from-files');; 
            	}
            }
        }
        ksort($folders);
        $template_selector = '<select name="template" id="template_selector">';
        $default = 'default';
        foreach ($folders as $key => $value) {
            
            $selected = '';
            if ($key == $default) {
                $selected = 'selected="selected"';
            }
            
            $template_selector .= '<option value="'.$key.'" '.$selected.'>' . $value . '</option>';
        }                             
        $template_selector .= '</select>';
        
        ?>
        <div id="download-from-files-tree-block" style="display: none;">
            <div style="margin-top: 6px;">
                <label for="search_download"><?php echo __('Search');?>:</label>
                <input id="search_download" type="text" value="" />
            </div>
            <div id="download_from_files_tree" data-path="/" > 
            </div>             
            <div style="display: inline-block;margin-right:20px;">
            <?php echo $template_selector; ?>
            </div>
            <div class="download-insert-functions" style="display: inline-block;">
                <input type="checkbox" id="show_folders" value="1" <?php echo $checked;?> />
                <small><?php echo __('Show chlidren folders', 'download-from-files');?></small>                        
            </div>
            <div style="text-align: center;margin-top: 10px;">
                <button class="button secondary" id="cancelFileDownload"><?php echo __( "Cancel", "download-from-files" );?></button>
                <button class="button primary" id="insertFileDownload" disabled="disabled"><?php echo __( "Insert download", "download-from-files" );?></button>
            </div>
        </div>
        <?php
    }
}
add_action('admin_footer', 'download_from_files_617_admin_footer', 11);
