<?php

    function sanitize_text_field($text)
    {
        $text = strip_tags($text);
        $text = htmlspecialchars($text);
        return $text;
    }

    function getIcon($ext)
    {
        switch ($ext){ 
        	case 'folder':
        	   $icon = 'folder.png';
               break;
            
            case 'exe':
        	   $icon = 'exe.png';
               break;
    
        	case 'doc':
        	case 'docx':
        	case 'odt':
        	   $icon = 'doc.png';
               break;
    
        	case 'xls':
        	case 'xlsx':
        	case 'ods':
        	case 'xml':
        	case 'csv':
        	   $icon = 'xls.png';
               break;
    
        	case 'ppt':
        	case 'pptx':
        	   $icon = 'ppt.png';
               break;
    
        	case 'sql':
        	case 'dump':
        	   $icon = 'sql.png';
         	   break;
    
        	case 'zip':
        	case 'rar':
        	case 'arj':
        	case 'tgz':
        	   $icon = 'package.png';
               break;
        
        	case 'txt':
        	   $icon = 'text.png';
               break;
        
        	case 'pdf':
        	   $icon = 'pdf.png';
               break;
    
        	case 'gif':
        	case 'jpg':
        	case 'png':
        	   $icon = 'img.png';
               break;
    
    
        	default :
                $icon = 'file.png';
        }            
        return $icon;
    }
   
    $id = sanitize_text_field($_REQUEST['id']);
    $path = sanitize_text_field($_REQUEST['path']);
    if ($path == 'false') {
        $path = '';
    }
    $root = sanitize_text_field($_REQUEST['root']);

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
    }
    $source = new JDovi42Files($root .DIRECTORY_SEPARATOR. $path);

    if (isset($_REQUEST['disabled'])) {
        $disabled = $_REQUEST['disabled'];
        for ($i = 0; $i <= count($disabled)-1; $i++) {
        	$disabled[$i] = sanitize_text_field($disabled[$i]);
        }
        $source->addTilt($disabled);
    }

    if ((isset($_REQUEST['sort_folders'])) and ($_REQUEST['sort_folders'] != 'set')) {
        $source->folderSort = 'SortBy' . ucfirst($_REQUEST['sort_folders']);
    } else {
        $source->folderSort = 'sortByList';
    }
    if (isset($_REQUEST['sort_order'])) {
        if ($_REQUEST['sort_order'] == 'asc') { $source->folderSortOrder = 'asc'; }
        if ($_REQUEST['sort_order'] == 'desc') { $source->folderSortOrder = 'desc'; }
    }
    $dirs = $source->getFolders();
    
    if ((isset($_REQUEST['sort_files'])) and ($_REQUEST['sort_files'] != 'set')) {
        $source->filesSort = 'SortBy' . ucfirst($_REQUEST['sort_files']);
    } else {
        $source->filesSort = 'sortByList';
    }
    if (isset($_REQUEST['sort_order'])) {
        if ($_REQUEST['sort_order'] == 'asc') { $source->filesSortOrder = 'asc'; }
        if ($_REQUEST['sort_order'] == 'desc') { $source->filesSortOrder = 'desc'; }
    }
    $source->allowExt = explode(',', sanitize_text_field($_REQUEST['ext']));
    $files = $source->getFiles();
    
    $url = sanitize_text_field($_REQUEST['url']);

    $html = '<ul>';
    foreach ($dirs as $dir) {
        $html .= '<li class="jstree-closed" id="'.$dir['name'].'" '.
                 'data-jstree=\'{"icon": "'.$url . getIcon('folder').'"}\' '.
                 'data-path="'.$id .DIRECTORY_SEPARATOR. $dir['name'].'">' . $dir['title'] . '</li>';
    }


    if ((isset($_REQUEST['template'])) and !empty($_REQUEST['template'])) {
        $tmpl = file_get_contents($_REQUEST['template']);
    } else {
        $tmpl = '<li
                    data-jstree=\'{"icon": "<!-- icon -->"}\'
                    data-file="<!-- path -->" data-filename="<!-- file -->" data-type="<!-- ext -->"><!-- title --> <small>(<!-- type -->, <!-- size_text -->)</small></li>';
    } 

    foreach ($files as $file) {
        
        $filepath = $path .DIRECTORY_SEPARATOR. $file['filename'];

        $tmp = $tmpl;
    
        $options = array(
            'icon'  => $url . getIcon($file['ext']),
            'path'  => $filepath,
            'file'  => $file['name'],
            'ext'   => $file['ext'],
            'title' => $file['title'],
            'type'  => strtoupper($file['ext']),
            'size_text' => $file['size_text'],
            'size'  => $file['size']
        );

        foreach ($options as $key => $value) {
            $tmp = str_replace('<!-- ' .$key. ' -->', $value, $tmp);
        }
        $html .= $tmp;
        
        /*
        $html .= '<li '.
                 'data-jstree=\'{"icon": "'.$url . getIcon($file['ext']).'"}\' '.
                 'data-file="'.$filepath.'" data-filename="'.$file['name'].'" data-type="'.$file['ext'].'">' . $file['title'] . ' <small>('.strtoupper($file['ext']).', '.$file['size_text'].')</small></li>';
        */                       
    }
    $html .= '</ul>';
    echo $html;        

?>