<?php

    function sanitize_text_field($text)
    {
        $text = strip_tags($text);
        $text = htmlspecialchars($text);
        return $text;
    }

    function getIcon($ext)
    {
        switch ($ext){ 
        	case 'exe':
        	   $icon = 'exe.png';
               break;
    
        	case 'doc':
        	case 'docx':
        	case 'odt':
        	   $icon = 'doc.png';
               break;
    
        	case 'xls':
        	case 'xlsx':
        	case 'ods':
        	case 'xml':
        	case 'csv':
        	   $icon = 'xls.png';
               break;
    
        	case 'ppt':
        	case 'pptx':
        	   $icon = 'ppt.png';
               break;
    
        	case 'sql':
        	case 'dump':
        	   $icon = 'sql.png';
         	   break;
    
        	case 'zip':
        	case 'rar':
        	case 'arj':
        	case 'tgz':
        	   $icon = 'package.png';
               break;
        
        	case 'txt':
        	   $icon = 'text.png';
               break;
        
        	case 'pdf':
        	   $icon = 'pdf.png';
               break;
    
        	case 'gif':
        	case 'jpg':
        	case 'png':
        	   $icon = 'img.png';
               break;
    
    
        	default :
                $icon = 'file.png';
        }            
        return $icon;
    }
   
    $id = sanitize_text_field($_REQUEST['id']);
    $path = sanitize_text_field($_REQUEST['path']);
    if ($path == 'false') {
        $path = '';
    }
    $root = sanitize_text_field($_REQUEST['root']);

    if (!class_exists ('JDovi42Files', false)) {
        include_once(dirname(__file__) .DIRECTORY_SEPARATOR. 'jdovi42_files.php');
    }
    $source = new JDovi42Files($root .DIRECTORY_SEPARATOR. $path);

    if (isset($_REQUEST['disabled'])) {
        $disabled = $_REQUEST['disabled'];
        for ($i = 0; $i <= count($disabled)-1; $i++) {
        	$disabled[$i] = sanitize_text_field($disabled[$i]);
        }
        $source->addTilt($disabled);
    }

    $source->folderSort = 'sortByList';
    $dirs = $source->getFolders();
    
    $source->filesSort = 'sortByList';
    $source->allowExt = explode(',', sanitize_text_field($_REQUEST['ext']));
    $files = $source->getFiles();
    
    $html = '<ul>';
    foreach ($dirs as $dir) {
        $html .= '<li class="jstree-closed" id="'.$dir['name'].'" '.
                 'data-path="'.$id .DIRECTORY_SEPARATOR. $dir['name'].'">' . $dir['title'] . '</li>';
    }

    $url = sanitize_text_field($_REQUEST['url']);

    if (!empty($files)) {
        foreach ($files as $file) {
            
            $filepath = $path .DIRECTORY_SEPARATOR. $file['filename'];
            
            $html .= '<li '.
                     'data-jstree=\'{"icon": "'.$url . getIcon($file['ext']).'"}\' '.
                     'data-file="'.$filepath.'">' . $file['title'] . '</li>';        
        }
    }
    
    $html .= '</ul>';
    echo $html;        

?>