<?php

    if ( !defined( 'ABSPATH' ) ) exit;

    class JDownloadFromTree617 extends stdClass
    {
        private $options = null;
        private $template_folder = '';
        
        public function __construct($options)
        {
            $this->options = $options;
            $this->options['token'] = $this->getToken();

            $this->options['url'] = plugins_url( 'download-from-files/assets/icons/', DOWNLOAD_FROM_FILES_617_ROOT );
            
            $pos = strpos($this->options['url'], '://');
            if ($pos !== false) {
                $this->options['url'] = substr($this->options['url'], ($pos + 1));
            }
            
            $this->options['home'] = home_url('/');
            
            $this->options['tmpl'] = '';
            if (file_exists(get_stylesheet_directory() .DIRECTORY_SEPARATOR. 'download-from-files' .DIRECTORY_SEPARATOR. 'tree' .DIRECTORY_SEPARATOR. 'file.html')) {
                $this->options['tmpl'] = get_stylesheet_directory() .DIRECTORY_SEPARATOR. 'download-from-files' .DIRECTORY_SEPARATOR. 'tree' .DIRECTORY_SEPARATOR. 'file.html';
            } else {
                if (file_exists(DOWNLOAD_FROM_FILES_617_ROOT .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. 'tree' .DIRECTORY_SEPARATOR. 'file.html')) {
                    $this->options['tmpl'] = DOWNLOAD_FROM_FILES_617_ROOT .DIRECTORY_SEPARATOR. 'templates' .DIRECTORY_SEPARATOR. 'tree' .DIRECTORY_SEPARATOR. 'file.html';
                }
            }
            
            $this->load_scripts_and_styles();
            
        }

        private function getToken()
        {
            $chars = 'ABCDEFGHIJKLMNOPQURSTXYVWZ0123456789';
            $token = '';
            for ($i = 1; $i <= 10; $i++) {
            	$token .= substr($chars, rand(0, strlen($chars)-1), 1);
            }                
            return $token;
        }
        
        function load_scripts_and_styles() {
            
            if (!defined('DOWNLOAD_FROM_TREE_617')) {
                wp_enqueue_style( 'dovi_download_tree', plugins_url( 'download-from-files/assets/css/jstree.style.css', DOWNLOAD_FROM_FILES_617_ROOT), false, '1.0.0' );
                wp_enqueue_style( 'download-from-tree-css', plugins_url( 'download-from-files/assets/css/frontend-tree.css', DOWNLOAD_FROM_FILES_617_ROOT), false, DOWNLOAD_FROM_FILES_617_VERSION );

                $sets = array(
                        'ABSPATH' => DOWNLOAD_FROM_FILES_617_WP_ROOT,
                        'loading_please_wait_text' => __('Loading, please wait ...', 'download-from-files'),
                        'downloads_from_files_plugin_url' => plugins_url( 'download-from-files/libs/load-folders-frontend.php', DOWNLOAD_FROM_FILES_617_ROOT )
                    );
                        
                wp_register_script('download-from-tree', plugins_url( 'download-from-files/assets/js/jstree.js', DOWNLOAD_FROM_FILES_617_ROOT ), array('jquery'), '1.0', true);
        		wp_localize_script('download-from-tree', 'download_from_files_617_ajax_object', array( 'ajax_url' => admin_url( 'admin-ajax.php' ) ) );
                wp_localize_script('download-from-tree', 'download_from_tree_sets', $sets, DOWNLOAD_FROM_FILES_617_VERSION);
                wp_enqueue_script('download-from-tree');

                wp_register_script('download-from-tree-class', plugins_url( 'download-from-files/assets/js/download-tree.js', DOWNLOAD_FROM_FILES_617_ROOT ), array('download-from-tree'), DOWNLOAD_FROM_FILES_617_VERSION, true);
                wp_enqueue_script('download-from-tree-class');

            }

            if (!defined('DOWNLOAD_FROM_TREE_617')) {
                define('DOWNLOAD_FROM_TREE_617', 1);
            }

            wp_register_script('download-from-tree-'.$this->options['token'], '', array('jquery'), DOWNLOAD_FROM_FILES_617_VERSION, true);
            wp_localize_script('download-from-tree-'.$this->options['token'], 'download_from_files_variables_'.$this->options['token'], $this->options);
            wp_enqueue_script('download-from-tree-'.$this->options['token']);
            
        }
        
        function prepareContent() {   

            if (has_filter('download_from_files_tree_search')) {
                $html = apply_filters('download_from_files_tree_search', $this->options);
            } else {
                $html = '';
            }

            $html .= '<div id="download_from_tree_'.$this->options['token'].'" class="download-from-tree" data-token="'.$this->options['token'].'">'.
                     '</div>';
            return $html;
        }
        

    }